// MethodPointersDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MethodPointers.h"
#include "MethodPointersDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMethodPointersDlg dialog

CMethodPointersDlg::CMethodPointersDlg(CWnd* pParent /*=NULL*/) : m_AverageMethodPtr( &m_AverageObject, AVERAGEMETHOD(Function1) ), m_SumMethodPtr( &m_SumObject, SUMMETHOD(Function1) ),
	CDialog(CMethodPointersDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMethodPointersDlg)
	m_nReturn = 0;
	m_nF2A1 = 0;
	m_nF2A2 = 0;
	m_nF3A1 = 0;
	m_nF3A2 = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_nFunc = 1;
}

void CMethodPointersDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMethodPointersDlg)
	DDX_Text(pDX, IDC_RETURN, m_nReturn);
	DDX_Text(pDX, IDC_F2A1, m_nF2A1);
	DDX_Text(pDX, IDC_F2A2, m_nF2A2);
	DDX_Text(pDX, IDC_F3A1, m_nF3A1);
	DDX_Text(pDX, IDC_F3A2, m_nF3A2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMethodPointersDlg, CDialog)
	//{{AFX_MSG_MAP(CMethodPointersDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CALL_SUM, OnCallSum)
	ON_BN_CLICKED(IDC_CALL_AVERAGE, OnCallAverage)
	ON_BN_CLICKED(IDC_FUNC1, OnFunc1)
	ON_BN_CLICKED(IDC_FUNC2, OnFunc2)
	ON_BN_CLICKED(IDC_FUNC3, OnFunc3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMethodPointersDlg message handlers

BOOL CMethodPointersDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	((CButton*)GetDlgItem( IDC_FUNC1 ))->SetCheck( 1 );
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMethodPointersDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMethodPointersDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMethodPointersDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMethodPointersDlg::OnCallSum() 
{
	// Pass in the sum methods
	CallTheMethod( (CMethodPtrBaseint*)&m_SumMethodPtr );
}

void CMethodPointersDlg::OnCallAverage() 
{
	// Pass in the average methods
	CallTheMethod( (CMethodPtrBaseint*)&m_AverageMethodPtr );	
}

void CMethodPointersDlg::OnFunc1() 
{
	// Set the pointers to function 1 which has no arguments
	m_nFunc = 1;
	m_AverageMethodPtr.SetMethod( AVERAGEMETHOD( Function1 ) );
	m_SumMethodPtr.SetMethod( SUMMETHOD( Function1 ) );
}

void CMethodPointersDlg::OnFunc2() 
{
	// Set the pointers to function 2 which has 2 arguments
	m_nFunc = 2;
	m_AverageMethodPtr.SetMethod( AVERAGEMETHOD( Function2 ) );
	m_SumMethodPtr.SetMethod( SUMMETHOD( Function2 ) );
}

void CMethodPointersDlg::OnFunc3() 
{
	// Set the pointers to function 3 which has 3 arguments
	m_nFunc = 3;
	m_AverageMethodPtr.SetMethod( AVERAGEMETHOD( Function3 ) );
	m_SumMethodPtr.SetMethod( SUMMETHOD( Function3 ) );
}

// why pass the abstract base class? Because the derived classes require
// much more template information
// we only care about the return type, but not which method or which object
void CMethodPointersDlg::CallTheMethod( CMethodPtrBaseint* pMethodPtrBase )
{
	::AfxMessageBox( "In CallTheMethod()" );
	UpdateData( TRUE );

	// Decide the correct number of arguments
	// Notice we call the same function in the abstract base class
	// but depending on if it is the sum or average, that function gets called

	switch ( m_nFunc )
	{
		case 1: // no arguments
			m_nReturn = pMethodPtrBase->CallMethod();
			break;
		case 2:   // two arguments, but different functions!!!!!!!
		case 3:
			m_nReturn = pMethodPtrBase->CallMethod(&m_nF2A1, &m_nF2A2);
	}

	UpdateData( FALSE );
}
